/*
 File: enumerate_grammar.h
 Date and Time: Fri Jan 30 18:55:09 2015 
*/
#ifndef __enumerate_grammar_h__
#define __enumerate_grammar_h__ 1
#include "yacco2.h"
#include "yacco2_T_enumeration.h"
#include "yacco2_k_symbols.h"
#include "yacco2_err_symbols.h"
#include "yacco2_terminals.h"
#include "yacco2_characters.h"

#include "o2_externs.h"
  
// monolithic grammar: no thread
extern yacco2::State S1_Cenumerate_grammar;
namespace NS_enumerate_grammar {
using namespace NS_yacco2_T_enum;// enumerate
using namespace yacco2;
struct fsm_rules_reuse_table_type{
 fsm_rules_reuse_table_type();
 int no_rules_entries_;
 Per_rule_s_reuse_table* per_rule_s_table_[9];
};
class Cenumerate_grammar: public yacco2::CAbs_fsm {
 public:
  enum rules_and_subrules{
   start_of_rule_list = NS_yacco2_T_enum::T_Enum::sum_total_T
   ,R_Rfirst_set_rules_ = 569//start_of_rule_list + 0
    ,rhs1_Rfirst_set_rules_ = 1
   ,R_Rrules_ = 570//start_of_rule_list + 2
    ,rhs1_Rrules_ = 2
    ,rhs2_Rrules_ = 3
   ,R_Rrule_ = 571//start_of_rule_list + 4
    ,rhs1_Rrule_ = 4
   ,R_Rrule_def_ = 572//start_of_rule_list + 6
    ,rhs1_Rrule_def_ = 5
   ,R_Rsubrules_ = 573//start_of_rule_list + 8
    ,rhs1_Rsubrules_ = 6
    ,rhs2_Rsubrules_ = 7
   ,R_Rsubrule_ = 574//start_of_rule_list + 10
    ,rhs1_Rsubrule_ = 8
   ,R_Rsubrule_def_ = 575//start_of_rule_list + 12
    ,rhs1_Rsubrule_def_ = 9
   ,R_Relements_ = 576//start_of_rule_list + 14
    ,rhs1_Relements_ = 10
    ,rhs2_Relements_ = 11
   ,R_Relement_ = 577//start_of_rule_list + 16
    ,rhs1_Relement_ = 12
    ,rhs2_Relement_ = 13
    ,rhs3_Relement_ = 14
    ,rhs4_Relement_ = 15
    ,rhs5_Relement_ = 16
  };
  //no of la sets = 6
  //no of states = 20
  Cenumerate_grammar();
  ~Cenumerate_grammar();
  void op();
  bool failed();
  void reduce_rhs_of_rule
      (yacco2::UINT Sub_rule_no,yacco2::Rule_s_reuse_entry** Recycled_rule);
  fsm_rules_reuse_table_type fsm_rules_reuse_table;
  static int rhs_to_rules_mapping_[17];
  
    public:
  int rule_no_;
  int subrule_no_;
  int enum_subrule_no_;
  int elem_no_;
  
 };
struct Rfirst_set_rules;
struct Rrules;
struct Rrule;
struct Rrule_def;
struct Rsubrules;
struct Rsubrule;
struct Rsubrule_def;
struct Relements;
struct Relement;
struct Rfirst_set_rules:public yacco2::CAbs_lr1_sym {
  Rfirst_set_rules(yacco2::Parser* P);
  public:
};

struct Rrules:public yacco2::CAbs_lr1_sym {
  Rrules(yacco2::Parser* P);
  public:
};

struct Rrule:public yacco2::CAbs_lr1_sym {
  Rrule(yacco2::Parser* P);
  public:
};

struct Rrule_def:public yacco2::CAbs_lr1_sym {
  Rrule_def(yacco2::Parser* P);
  public:
  void sr1();
};

struct Rsubrules:public yacco2::CAbs_lr1_sym {
  Rsubrules(yacco2::Parser* P);
  public:
};

struct Rsubrule:public yacco2::CAbs_lr1_sym {
  Rsubrule(yacco2::Parser* P);
  public:
};

struct Rsubrule_def:public yacco2::CAbs_lr1_sym {
  Rsubrule_def(yacco2::Parser* P);
  public:
  void sr1();
};

struct Relements:public yacco2::CAbs_lr1_sym {
  Relements(yacco2::Parser* P);
  public:
};

struct Relement:public yacco2::CAbs_lr1_sym {
  Relement(yacco2::Parser* P);
  public:
  void sr1();
  void sr2();
  void sr3();
  void sr4();
  void sr5();
};

} // end of namespace

#endif
